var oss = require('ali-oss');
var fs = require('fs');
var path = require('path'); //解析需要遍历的文件夹
const { join, sep } = require("path");
var filePath = path.resolve(__dirname + '/dist');

console.log(filePath);

var client = oss({
  accessKeyId: 'LTAI5tLHrA5K4tBGkoYR6TJT',
  accessKeySecret: '8u4TgUFWcrgvV1lljcsYCG1JgbVKEK',
  bucket: 'gstor-default-workspace-cn-shanghai-c218770b',
  region: 'oss-cn-shanghai',
});

//获取所有的bucket
async function listBuckets() {
  try {
    let result = await client.listBuckets();
    console.log(result);
  } catch (err) {
    console.log(err);
  }
}

// 查询单个存储空间
async function list() {
  try {
    //指定使用哪个bucket   不指定即为最顶部指定的那个bucket
    // client.useBucket('bucket名称');

    let result = await client.list({
      'max-keys': 5,
    });
    console.log(result);
  } catch (err) {
    console.log(err);
  }
}

// 单个上传文件
async function put() {
  try {
    //参数一：在bucket里面的名称，也是访问的名称   参数二：文件在当前项目中的路径
    let result = await client.put('img', '/src/assets/image/warningBtn.png');
    console.log(result);
  } catch (err) {
    console.log(err);
  }
}

// 下载文件
async function get() {
  try {
    //参数：存储时写入的名称
    let result = await client.get('img');
    console.log(result);
  } catch (err) {
    console.log(err);
  }
}

// 创建存储空间。
async function putBucket() {
  try {
    const clicent = {
      // storageClass: 'Archive', // 存储空间的默认存储类型为标准存储，即Standard。如果需要设置存储空间的存储类型为归档存储，请替换为Archive。
      acl: 'public-read', // 存储空间的默认读写权限为私有，即private。如果需要设置存储空间的读写权限为公共读，请替换为public-read。
      dataRedundancyType: 'ZRS', // 存储空间的默认数据容灾类型为本地冗余存储，即LRS。如果需要设置数据容灾类型为同城冗余存储，请替换为ZRS。
    };

    //名称是全网唯一的，注意尽量带前缀
    const result = await clicent.putBucket('<随意取bucket名称>');
    console.log(result);
  } catch (err) {
    console.log(err);
  }
}

// 上传文件
async function put() {
  try {
    //根据文件路径读取文件，返回文件列表
    fs.readdir(filePath, function(err, files) {
      // 文件名称
      // console.log(files);
      if (err) {
        console.warn(err);
      } else {
        //遍历读取到的文件列表
        files.forEach(function(filename) {
          console.log('11111')
          //获取当前文件的绝对路径
          var filedir = path.join(filePath, filename);
          // console.log(filedir.split('\\')[filedir.split('\\').length - 1]);
          // 上传
          let result = client.put(
            'map/' + filedir.split('\\')[filedir.split('\\').length - 1],
            './src/map/' + filedir.split('\\')[filedir.split('\\').length - 1],
          );
          console.log(result);
        });
      }
    });
  } catch (err) {
    console.log(err);
  }
}


function send(dir, output) {
  let files = fs.readdirSync(dir);
  files.forEach((item, index) => {
      // 过滤无效文件
      if (item.indexOf(".") === 0 || item.indexOf(".html") > -1) {
          return;
      }
      let fPath = join(dir, item);
      let stat = fs.statSync(fPath);
      if (stat.isDirectory() === true) {
          send(fPath, join(output, item));
      }
      if (stat.isFile() === true) {
          console.log(fPath);
          let target = join(output, item)
              .split(sep)
              .join("/");
          client.put(target, fPath);
      }
  });
}

send(join(__dirname, "/dist"), '/umi-testProject/');

///需要执行哪个方法取消注释即可
///需要执行哪个方法取消注释即可
///需要执行哪个方法取消注释即可

//查询所有bucket
//  listBuckets();

//查询指定bucket内容
// list();

//上传单个文件
put();

//上传文件夹
//putfile()

//下载bucket里指定的内容
//get();

//创建bucket
//putBucket();
