/**
 * 路由的配置
 */
export default [
  {
    path: '/',
    component: '@/layouts/BasicLayout',
    routes: [
      { path: '/', redirect: '/codeDiff' },

      // hooks 例子
      { path: '/hooks', component: '@/pages/hooks/index' },

      // StyledComponents 例子
      { path: '/styledComponents', component: '@/pages/StyledComponents' },

      // rxjs 例子
      { path: '/rxjs', component: '@/pages/Rxjs' },

      // sentry 例子
      { path: '/sentry', component: '@/pages/Sentry' },

      // ep
      { path: '/ep', component: '@/pages/Ep' },

      // 测试页面
      { path: '/testPage', component: '@/pages/TestPage' },

      // 导出表格
      { path: '/exportExcel', component: '@/pages/ExportExcel' },

      // 代码比较
      { path: '/codeDiff', component: '@/pages/CodeDiff' },

      // dag图
      { path: '/dagTest', component: '@/pages/DagTest' },

      // react-redux 源码解析
      { path: '/ReactRedux', component: '@/pages/ReactRedux' },

      // react-redux 源码解析
      { path: '/Prettier', component: '@/pages/Prettier' },

      // CDN jsdelivr
      { path: '/CDNjsdelivr', component: '@/pages/CDNjsdelivr' },

      // 测试2
      { path: '/test2', component: '@/pages/Test2' },

      // 电厂1
      { path: '/page1', component: '@/pages/electricity/Page1' },

      // 电厂2
      { path: '/page2', component: '@/pages/electricity/Page2' },

      // 接口监控
      { path: '/page3', component: '@/pages/electricity/Page3' },

      // 数据治理
      { path: '/page4', component: '@/pages/electricity/Page4' },

      // 首页
      { path: '/page5', component: '@/pages/electricity/Page5' },

      // 首页
      { path: '/page6', component: '@/pages/electricity/Page6' },

      // 切换主题
      { path: '/themeChange', component: '@/pages/ThemeChange' },

      // 流程图设置
      { path: '/BpmnTest', component: '@/pages/BpmnTest' },

      // 画布
      { path: '/Konva', component: '@/pages/Konva' },

      // 画布
      { path: '/emotion', component: '@/pages/Emotion' },

      // js添加class
      { path: '/StyledComponentsTest', component: '@/pages/StyledComponentsTest' },

      // scoket
      { path: '/Scoket', component: '@/pages/Scoket' },

      // 远程组件
      { path: '/remoteComp', component: '@/pages/RemoteComp' },
      
    ],
  },
];
